<?php


class Zadarma {
	
	
	// проверка приходящих данных методом _POST
	public static function Load(){
		require_once(DIR_FS_CATALOG.'plugins/zadarma/classes/ZadarmaJournal.php');
		require_once(DIR_FS_CATALOG.'plugins/zadarma/classes/ZadarmaOperators.php');
		require_once(DIR_FS_CATALOG.'plugins/zadarma/classes/ZadarmaSettings.php');
		require_once(DIR_FS_CATALOG.'plugins/zadarma/classes/ZadarmaContact.php');
		
		self::CreateTable();
		ZadarmaSettings::Load();
	}

	// проверка приходящих данных методом _POST
	public static function isPost($name){
		return isset($_POST[$name])&&strlen(trim($_POST[$name]))>0;
	}
	
	// проверка приходящих данных методом _GET
	public static function isGet($name){
		return isset($_GET[$name])&&strlen(trim($_GET[$name]))>0;
	}
	
	// если данные пришли через POST, то заполняемих в фрму
	public static function ReValuePost($name,$default=null){
		return isset($_POST[$name])?htmlspecialchars($_POST[$name]):$default;
	}
	
	// если данные пришли через GET, то заполняемих в фрму
	public static function ReValueGET($name,$default=null){
		return isset($_GET[$name])?htmlspecialchars($_GET[$name]):$default;
	}
	
	public static function CreateTable(){
		db_query("CREATE TABLE IF NOT EXISTS `app_zadarma_journal` (
			`journal_id` int auto_increment primary key, 
			`journal_zadarma_id` varchar(255),
			`journal_date` INT NOT NULL,
			`journal_time` varchar(255),
			`journal_event` varchar(255),
			`journal_caller_id` varchar(255),
			`journal_called_did` varchar(255),
			`journal_destination` varchar(255),
			`journal_internal` varchar(255),
			`journal_duration` varchar(255),
			`journal_disposition` varchar(255),
			`journal_status_code` varchar(255),
			`journal_is_recorded` varchar(255),
			`journal_call_id_with_rec` varchar(255),
			`journal_mp3`  varchar(255) default NULL
		) ENGINE=InnoDB CHARACTER SET=utf8");
		db_query("CREATE TABLE IF NOT EXISTS `app_zadarma_operators` (
			`operators_id` int auto_increment primary key, 
			`operators_user_id` INT NOT NULL,
			`operators_phone` varchar(255)
		) ENGINE=InnoDB CHARACTER SET=utf8");
		db_query("CREATE TABLE IF NOT EXISTS `app_zadarma_settings` (
			`settings_id` int auto_increment primary key, 
			`settings_param` varchar(255) NOT NULL,
			`settings_val` TEXT
		) ENGINE=InnoDB CHARACTER SET=utf8");
	}
	
	public static function phone($phone){
		$phone = preg_replace("/[^0-9]*/",'',$phone);
		if(mb_strlen($phone) != 11) return(false);
		$sCountry = "+".(mb_substr($phone,0,1)==8?7:mb_substr($phone,0,1));
		$sArea = mb_substr($phone,1,3);
		$sPrefix = mb_substr($phone,4,3);
		$sNumber = mb_substr($phone,7,2);
		$sNumber2 = mb_substr($phone,9,2);
		$phone = $sCountry."(".$sArea.")".$sPrefix."-".$sNumber."-".$sNumber2; 
		return($phone);
	}
	
}