<?php

class ZadarmaJournal {
	
	public static $disposition = array('answered'=>'разговор',
								'busy'=>'занято',
								'cancel'=>'отменен',
								'no answer'=>'без ответа',
								'failed'=>'не удался',
								'no money'=>'нет средств, превышен лимит',
								'unallocated number'=>'номер не существует',
								'no limit'=>'превышен лимит',
								'no day limit'=>'превышен дневной лимит',
								'line limit'=>'превышен лимит линий',
								'no money, no limit'=>'превышен лимит');
	public static $cssdisposition = array('answered'=>'bg-success',
								'busy'=>'bg-danger',
								'cancel'=>'bg-warning',
								'no answer'=>'bg-danger',
								'failed'=>'bg-warning',
								'no money'=>'bg-secondary',
								'unallocated number'=>'bg-secondary',
								'no limit'=>'bg-secondary',
								'no day limit'=>'bg-secondary',
								'line limit'=>'bg-secondary',
								'no money, no limit'=>'bg-secondary');
	
	public static $ZadarmaJournalList = array();
	public static $CacheFileJournal = DIR_FS_CACHE."/app_zadarma_journal.php";
	public static $PLUGIN_ZADARMA_SQL = NULL;

	public static function getCalls($page=1,$limit=false){
		if($limit==false){ $limit=PLUGIN_ZADARMA_COUNTITEMJOURNAL; }
		ZadarmaOperators::getCallers();
		ZadarmaContact::getContactList();
		$calls = self::getCallsDistinct($page,$limit);
		foreach($calls as $id=>$call){
			$query = db_query("select * from `app_zadarma_journal` WHERE `journal_zadarma_id`='".db_input($id)."' ORDER By `journal_date`");
			$calls[$id]=array();
			$calls[$id]['caller_link']=null;
			while($item = db_fetch_array($query)){
				if(isset($item['journal_internal'])&&mb_strlen($item['journal_internal'])>0){
					if(in_array($item['journal_event'],array('NOTIFY_INTERNAL','NOTIFY_END'))){
						$calls[$id]['items'][$item['journal_internal']] = array(
							"internal"=>$item['journal_internal'],
							"respondent"=>ZadarmaOperators::$Callers[$item['journal_internal']]['field_7']." ".ZadarmaOperators::$Callers[$item['journal_internal']]['field_8'],
							"respondent_link"=>url_for('items/info','path='.PLUGIN_ZADARMA_TABLEID.'-'.ZadarmaOperators::$Callers[$item['journal_internal']]['id'].'&gotopage[70]=1'),
							"phone"=>$item['journal_internal'],
							"status"=>($item['journal_event']=='NOTIFY_END'?self::$disposition[$item['journal_disposition']]:'Занято'),
							"css_bg"=>($item['journal_event']=='NOTIFY_END'?self::$cssdisposition[$item['journal_disposition']]:'bg-danger'),
						);
					} else {
						$calls[$id]['items'][$item['journal_internal']] = array(
							"internal"=>$item['journal_internal'],
							"respondent"=>Zadarma::phone($item['journal_destination']),
							"phone"=>Zadarma::phone($item['journal_destination']),
							"status"=>($item['journal_event']=='NOTIFY_OUT_END'?self::$disposition[$item['journal_disposition']]:'Занято'),
							"css_bg"=>($item['journal_event']=='NOTIFY_OUT_END'?self::$cssdisposition[$item['journal_disposition']]:'bg-danger'),
						);  
						$phone = Zadarma::phone($item['journal_destination']);
						if(mb_substr($phone,0,1)=="+"&&isset(ZadarmaContact::$ContactsList[$phone]['name'])){
							$calls[$id]['items'][$item['journal_internal']]['respondent']=ZadarmaContact::$ContactsList[$phone]['name']; // имя звонящего
							$calls[$id]['items'][$item['journal_internal']]['respondent_link']=url_for('items/info','path='.PLUGIN_ZADARMA_TABLEID.'-'.ZadarmaContact::$ContactsList[$phone]['id'].'&gotopage[70]=1');
							$calls[$id]['items'][$item['journal_internal']]['phone']=$phone; // имя звонящего
							$calls[$id]['items'][$item['journal_internal']]['caller_isadd']=false; // запретить добавление
						} else {
							$calls[$id]['items'][$item['journal_internal']]['respondent']=$phone; // телефон звонящего
							$calls[$id]['items'][$item['journal_internal']]['respondent_link']=null;
							$calls[$id]['items'][$item['journal_internal']]['phone']=$phone; // телефон звонящего
							$calls[$id]['items'][$item['journal_internal']]['caller_isadd']=true; // разрешить добавление
						}
					}
				}
				if(in_array($item['journal_event'],array('NOTIFY_END','NOTIFY_OUT_END'))||$calls[$id]['caller']==null){
					if(mb_strlen($item['journal_mp3'])>10&&file_exists(DIR_FS_CATALOG.$item['journal_mp3'])){
						$calls[$id]['mp3']="/".$item['journal_mp3'];
					} else {
						$calls[$id]['mp3']=false;
					}
					$calls[$id]['internal']=$item['journal_internal']; 
					$calls[$id]['call_start']=$item['journal_time']; // старт звонка
					$calls[$id]['duration']=$item['journal_duration']; // длительность
					$calls[$id]['disposition']=self::$disposition[$item['journal_disposition']]; // состояние
					$calls[$id]['css_bg']=self::$cssdisposition[$item['journal_disposition']];
					if($item['journal_event']=='NOTIFY_END'||$calls[$id]['caller']==null){
						$phone = Zadarma::phone($item['journal_caller_id']);
						$calls[$id]['phone']=$phone;
						if(mb_substr($phone,0,1)=="+"&&isset(ZadarmaContact::$ContactsList[$phone]['name'])){
							$calls[$id]['caller']=ZadarmaContact::$ContactsList[$phone]['name']; // имя звонящего
							$calls[$id]['caller_link']=url_for('items/info','path='.PLUGIN_ZADARMA_TABLEID.'-'.ZadarmaContact::$ContactsList[$phone]['id'].'&gotopage[70]=1');
							$calls[$id]['caller_isadd']=false; // запретить добавление
						} else {
							$calls[$id]['caller']=$phone; // телефон звонящего
							$calls[$id]['caller_isadd']=true; // разрешить добавление
						}
					} elseif($item['journal_event']=='NOTIFY_OUT_END'||$calls[$id]['caller']==null){
						$calls[$id]['caller']=ZadarmaOperators::$Callers[$item['journal_internal']]['field_7']." ".ZadarmaOperators::$Callers[$item['journal_internal']]['field_8']; 
					}
				} 
			}
		}
		return $calls; 
	}
	
	
	public static function getCallsDistinct($page=1,$limit=false){
		if($limit==false){ $limit=PLUGIN_ZADARMA_COUNTITEMJOURNAL; }
		$limitStart = $limit*$page-$limit;
		$query = db_query("select DISTINCT `journal_zadarma_id` from `app_zadarma_journal`".ZadarmaJournal::$PLUGIN_ZADARMA_SQL." ORDER By `journal_date` DESC LIMIT ".$limitStart.",".$limit);
		$calls = array();
		while($call = db_fetch_array($query)){ 
			$calls[$call['journal_zadarma_id']] = $call['journal_zadarma_id'];
		}
		return $calls;
	}
	
	public static function getNavigationJournalList($target,$limit=false){
		if($limit==false){ $limit=PLUGIN_ZADARMA_COUNTITEMJOURNAL; }
		$query = db_query("select COUNT(DISTINCT `journal_zadarma_id`) as `count` from `app_zadarma_journal`".ZadarmaJournal::$PLUGIN_ZADARMA_SQL);
		$count = db_fetch_array($query);
		return self::generator_navigation_number($count['count'],$target,$limit);
	}
	
	
	
	/* Метод для генерации номеров страниц, например в новостях, возвращает нужный массив состоящий из номеров страниц */
	public static function generator_navigation_number($count_element=0 /* всего элементов */,$target_number=1 /* текущий номер страницы */,$count_to_page=10 /* количество элементов на страницу */){
		$array=array();
		$count_element = (int)$count_element>0?(int)$count_element:0;
		$count_to_page = (int)$count_to_page>0?(int)$count_to_page:10;
		$vp=ceil($count_element/$count_to_page); // всего страниц
		// Если страниц менее 20, выводим полный перечень
		if($vp<=16){
			for($i=1;$i<=$vp;$i++){
				$array[]=$i;
			}
		// если страниц более 20 выводим первых 3, последних 3 и +-2 относительно текущей позиции
		} else {
			$array=$target_number>($vp-10)?array(1):array(1,2,3);
		
			if($target_number>=6&&$target_number<=($vp-5)){
				for($i=($target_number-2);$i<=($target_number+2);$i++){
					$array[]=$i;
				}
			} elseif($target_number>1&&($target_number<6)){ 
				for($i=4;$i<=($target_number+2);$i++){
					$array[]=$i;
				}
			} elseif($target_number<$vp&&$target_number>($vp-5)){
				for($i=($target_number-2);$i<=($vp-2);$i++){
					$array[]=$i;
				}
			}
		
			for($i=($target_number<10?$vp:$vp-1);$i<=$vp;$i++){
				$array[]=$i;
			}
		}
		return $array;
	}
		
	public static function addNotifyInternal($post){
		db_query("INSERT INTO `app_zadarma_journal` SET 
			`journal_zadarma_id`='".db_input($post['pbx_call_id'])."', 
			`journal_date`='".db_input(strtotime($post['call_start']))."',
			`journal_time`='".db_input($post['call_start'])."',
			`journal_event`='".db_input($post['event'])."',
			`journal_caller_id`='".db_input($post['caller_id'])."',
			`journal_called_did`='".db_input($post['called_did'])."',
			`journal_internal`='".db_input($post['internal'])."'
		");
	}  
  
	public static function addNotifyEnd($post){
		if(isset($post['internal'])){
			db_query("DELETE FROM `app_zadarma_journal` WHERE `journal_zadarma_id`='".db_input($post['pbx_call_id'])."' and `journal_internal`='".db_input($post['internal'])."'");
		}
		$query  = "`journal_zadarma_id`='".db_input($post['pbx_call_id'])."', 
			`journal_date`='".db_input(strtotime($post['call_start']))."',
			`journal_time`='".db_input($post['call_start'])."',
			`journal_event`='".db_input($post['event'])."',
			`journal_caller_id`='".db_input($post['caller_id'])."',
			`journal_called_did`='".db_input($post['called_did'])."',
			`journal_duration`='".db_input($post['duration'])."',
			`journal_disposition`='".db_input($post['disposition'])."',
			`journal_status_code`='".db_input($post['status_code'])."',
			`journal_is_recorded`='".db_input($post['is_recorded'])."'";
		if(isset($post['internal'])){
			$query  .= ", 
				`journal_internal`='".db_input($post['internal'])."',
				`journal_call_id_with_rec`='".db_input($post['call_id_with_rec'])."' 
			";
		}
		db_query("INSERT INTO `app_zadarma_journal` SET ".$query);
	}
	public static function addNotifyOutStart($post){ 
		db_query("INSERT INTO `app_zadarma_journal` SET 
			`journal_zadarma_id`='".db_input($post['pbx_call_id'])."', 
			`journal_date`='".db_input(strtotime($post['call_start']))."',
			`journal_time`='".db_input($post['call_start'])."',
			`journal_event`='".db_input($post['event'])."',
			`journal_caller_id`='".db_input($post['caller_id'])."',
			`journal_destination`='".db_input($post['destination'])."',
			`journal_internal`='".db_input($post['internal'])."'
		");
	}
	public static function addNotifyOutEnd($post){
		db_query("DELETE FROM `app_zadarma_journal` WHERE `journal_zadarma_id`='".db_input($post['pbx_call_id'])."'"); 
		$query  = "`journal_zadarma_id`='".db_input($post['pbx_call_id'])."', 
			`journal_date`='".db_input(strtotime($post['call_start']))."',
			`journal_time`='".db_input($post['call_start'])."',
			`journal_event`='".db_input($post['event'])."',
			`journal_caller_id`='".db_input($post['caller_id'])."',
			`journal_destination`='".db_input($post['destination'])."',
			`journal_internal`='".db_input($post['internal'])."',
			`journal_duration`='".db_input($post['duration'])."',
			`journal_disposition`='".db_input($post['disposition'])."',
			`journal_status_code`='".db_input($post['status_code'])."',
			`journal_is_recorded`='".db_input($post['is_recorded'])."',
			`journal_call_id_with_rec`='".db_input($post['call_id_with_rec'])."'";
		db_query("INSERT INTO `app_zadarma_journal` SET ".$query);
	}
	


}