<?php

class ZadarmaSettings {
	
	public static $SettingsList = array();
	public static $CacheFileSettings = DIR_FS_CACHE."/app_zadarma_settings.php";
	
	
	public static function Load(){ 
		self::LoadSettings(); 
		defined('PLUGIN_ZADARMA_APIKEY') or define('PLUGIN_ZADARMA_APIKEY', self::getSettings('ApiKeyZadarma',null));
		defined('PLUGIN_ZADARMA_APISECRET') or define('PLUGIN_ZADARMA_APISECRET', self::getSettings('ApiSecretZadarma',null));
		defined('PLUGIN_ZADARMA_COUNTITEMJOURNAL') or define('PLUGIN_ZADARMA_COUNTITEMJOURNAL', self::getSettings('CountItemJournal',20));
		
		defined('PLUGIN_ZADARMA_TABLEID') or define('PLUGIN_ZADARMA_TABLEID',self::getSettings('TableContactID',25));
		defined('PLUGIN_ZADARMA_TABLE_COLUMN_FULLNAME') or define('PLUGIN_ZADARMA_TABLE_COLUMN_FULLNAME',self::getSettings('TableContactFullName','field_213'));
		defined('PLUGIN_ZADARMA_TABLE_COLUMN_NAME') or define('PLUGIN_ZADARMA_TABLE_COLUMN_NAME',self::getSettings('TableContactName','field_214'));
		defined('PLUGIN_ZADARMA_TABLE_COLUMN_LASTNAME') or define('PLUGIN_ZADARMA_TABLE_COLUMN_LASTNAME',self::getSettings('TableContactLastName','field_215'));
		defined('PLUGIN_ZADARMA_TABLE_COLUMN_PHONE') or define('PLUGIN_ZADARMA_TABLE_COLUMN_PHONE',self::getSettings('TableContactPhone','field_216'));
		defined('PLUGIN_ZADARMA_TABLE_COLUMN_EMAIL') or define('PLUGIN_ZADARMA_TABLE_COLUMN_EMAIL',self::getSettings('TableContactEmail','field_217'));
		defined('PLUGIN_ZADARMA_SAVE_MP3_HOSTING') or define('PLUGIN_ZADARMA_SAVE_MP3_HOSTING',self::getSettings('SaveMp3Hosting','12'));
	}
	
	// load Settings db\cache
	public static function LoadSettings(){ 
		$LoadSettings = false;
		if(file_exists(self::$CacheFileSettings)){ $LoadSettings = unserialize(file_get_contents(self::$CacheFileSettings)); }
		if(is_array($LoadSettings)&&count($LoadSettings)>0&&isset($LoadSettings["time"])&&time()-3600>$LoadSettings["time"]){
			return self::$SettingsList = $LoadSettings['data'];
		} else {
			$app_zadarma_settings = db_query("select * from `app_zadarma_settings`");
			$settings = array();
			while($setting = db_fetch_array($app_zadarma_settings)){ 
				$settings[$setting['settings_param']] = $setting['settings_val'];
			}
			file_put_contents(self::$CacheFileSettings,serialize(array("time"=>time(),"data"=>$settings)));
			return self::$SettingsList = $settings; 
		}
	}
	

	public static function getSettings($id,$dedault=null){
		if(isset(self::$SettingsList[$id])){
			return self::$SettingsList[$id];
		} else {
			return $dedault;
		}
	}
	
	
	public static function setSettings($SettingsName,$value){
		$SettingsName = stripslashes(trim($SettingsName));
		db_query("DELETE FROM `app_zadarma_settings` WHERE `settings_param`='".db_input($SettingsName)."' LIMIT 1");
		db_query("INSERT INTO `app_zadarma_settings` SET `settings_param`='".db_input($SettingsName)."', `settings_val`='".db_input($value)."'");
		if(file_exists(self::$CacheFileSettings)){ unlink(self::$CacheFileSettings); }
	}
}