<?php
use Zadarma_API\Api;
use Zadarma_API\Client;

include_once DIR_FS_CATALOG."plugins/zadarma/Zadarma_API/lib/Client.php";
include_once DIR_FS_CATALOG."plugins/zadarma/Zadarma_API/lib/Api.php";

spl_autoload_register(function($class) {
	if(preg_match('/Zadarma_API/', $class)){
		include_once(DIR_FS_CATALOG."plugins/zadarma/".str_replace("\\","/",str_replace("Zadarma_API","Zadarma_API/lib",$class)).".php"); 
	}
});
$zd = new Api(PLUGIN_ZADARMA_APIKEY, PLUGIN_ZADARMA_APISECRET);

function CreatePath($path,$chmod,$log){ 
	if(!is_dir($path)){
		mkdir($path,$chmod);
		if(!is_dir($path)){
			echo "No create ".$path;
			exit();
		}
	}
} 

function LoadCurlFile($url,$path){
	$fp = fopen($path, 'w');
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_FILE, $fp);
	$data = curl_exec($ch);
	curl_close($ch);
	fclose($fp);
}

function CreateDir($link,$chmod=0777){
	if(!is_dir($link)){
		mkdir($link,$chmod);
		if(!is_dir($link)){
			echo "No create ".$link;
			exit();
		}
	}
}

function CreateSaveFilePath($date,$path='uploads/mp3/'){
	$link=DIR_FS_CATALOG;
	$pathExp = explode("/",$path);
	foreach($pathExp as $dir){
		if(mb_strlen($dir)>0){
			$link.=$dir."/";
			CreateDir($link);
		}
	}
	$link.=date("Y",$date)."/";
	CreateDir($link);
	$link.=date("m",$date)."/";
	CreateDir($link);
	$link.=date("d",$date)."/";
	CreateDir($link); 
	return $link;
}


$upload=array();
//`journal_is_recorded`='1' and `journal_mp3` IS NULL and `journal_date`<'".db_input(time()-100)."' LIMIT 1
//`journal_zadarma_id`='in_354e5753be3be00420b2a499e8aa1ba24714065f'
$query = db_query("select * from `app_zadarma_journal` WHERE `journal_is_recorded`='1' and `journal_mp3` IS NULL and `journal_date`<'".db_input(time()-100)."' LIMIT 1"); 
while($call = db_fetch_array($query)){ 
	$upload[$call['journal_zadarma_id']]=$call['journal_mp3'];
	$params = array(
		"pbx_call_id"=>$call['journal_zadarma_id'],
		"call_id"=>$call['journal_call_id_with_rec'],
	);
	$answer = $zd->call('/v1/pbx/record/request/', $params, 'get');
	$answerObject = (array)json_decode($answer);
	//$return = $zd->getPbxRecord($call['journal_zadarma_id'],$call['journal_call_id_with_rec']);
	//var_dump($answerObject);
	if(isset($answerObject["status"])&&$answerObject["status"]=="success"&&isset($answerObject["links"][0])&&mb_strlen($answerObject["links"][0])>0){
		$path = CreateSaveFilePath($call['journal_date'],'uploads/mp3/');
		$file = $path.$call['journal_zadarma_id'].".mp3";
		LoadCurlFile($answerObject["links"][0],$file); 
		
		db_query("UPDATE `app_zadarma_journal` SET 
			`journal_mp3`='".db_input(str_replace(DIR_FS_CATALOG,"",$file))."'
			WHERE `journal_zadarma_id`='".$call['journal_zadarma_id']."'
		");
	} else {
		db_query("UPDATE `app_zadarma_journal` SET 
			`journal_is_recorded`='0',
			`journal_mp3`=NULL
			WHERE `journal_zadarma_id`='".$call['journal_zadarma_id']."'
		");
	}
}

$time = time()-PLUGIN_ZADARMA_SAVE_MP3_HOSTING*30*86400;
$query = db_query("select * from `app_zadarma_journal` WHERE `journal_mp3` IS NOT NULL and `journal_date`<'".db_input($time)."' LIMIT 1"); 
//$query = db_query("select * from `app_zadarma_journal` WHERE `journal_mp3` IS NOT NULL and `journal_date`<'".db_input(time())."' LIMIT 1"); 
while($call = db_fetch_array($query)){
	if(file_exists(DIR_FS_CATALOG.$call['journal_mp3'])){ unlink(DIR_FS_CATALOG.$call['journal_mp3']); }
	db_query("UPDATE `app_zadarma_journal` SET 
		`journal_is_recorded`=NULL,
		`journal_mp3`=NULL
		WHERE `journal_zadarma_id`='".$call['journal_zadarma_id']."'
	");
}	



echo json_encode($upload);



exit();